Debian Bug report logs - #164889
[MD5SUM] md5sum must not output '-' when no argument supplied

Package: dpkg; Maintainer for dpkg is Dpkg Developers <debian-dpkg@lists.debian.org>; Source for dpkg is src:dpkg.

Reported by: Ian Jackson <ian@davenant.greenend.org.uk>

Date: Tue, 15 Oct 2002 19:33:04 UTC

Severity: important

Tags: fixed-in-experimental

Merged with 164591

Done: Scott James Remnant <scott@netsplit.com>

Bug is archived. No further changes may be made.

Toggle useless messages

View this report as an mbox folder, status mbox, maintainer mbox


Report forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
New Bug report received and forwarded. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #5 received at submit@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: submit@bugs.debian.org
Subject: md5sum <FILE produces spurious ` -' in output
Date: Tue, 15 Oct 2002 20:22:39 +0100
Package: dpkg
Version: 1.10.4

-davenant:~> dpkg -S /usr/bin/md5sum
dpkg: /usr/bin/md5sum
-davenant:~> dpkg -l dpkg
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Installed/Config-files/Unpacked/Failed-config/Half-installed
|/ Err?=(none)/Hold/Reinst-required/X=both-problems (Status,Err: uppercase=bad)
||/ Name           Version        Description
+++-==============-==============-============================================
ii  dpkg           1.6.15         Package maintenance system for Debian
-davenant:~> md5sum </dev/null 
d41d8cd98f00b204e9800998ecf8427e
-davenant:~> md5sum </dev/null | cat -vet
d41d8cd98f00b204e9800998ecf8427e$
-davenant:~> 

but

-anarres:~> dpkg -S /usr/bin/md5sum
dpkg: /usr/bin/md5sum
-anarres:~> dpkg -l dpkg
Desired=Unknown/Install/Remove/Purge/Hold
| Status=Not/Installed/Config-files/Unpacked/Failed-config/Half-installed
|/ Err?=(none)/Hold/Reinst-required/X=both-problems (Status,Err: uppercase=bad)
||/ Name           Version        Description
+++-==============-==============-============================================
ii  dpkg           1.10.4         Package maintenance system for Debian
-anarres:~> md5sum </dev/null 
d41d8cd98f00b204e9800998ecf8427e  -
-anarres:~> md5sum </dev/null | cat -vet
d41d8cd98f00b204e9800998ecf8427e  -$
-anarres:~> 

This breaks any scripts and other programs which rely on feeding
md5sum files on stdin to get it to print out just the hash with no
clutter etc.

Ian.



Reply sent to Adam Heath <adam@lapdoog.doogie.org>:
You have taken responsibility. Full text and rfc822 format available.

Notification sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Bug acknowledged by developer. Full text and rfc822 format available.

Message #10 received at 164889-done@bugs.debian.org (full text, mbox):

From: Adam Heath <adam@lapdoog.doogie.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>, <164889-done@bugs.debian.org>
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Wed, 16 Oct 2002 09:43:13 -0500 (CDT)
That's all well and good.  Use the bts.  This problem has already been
discussed, and resolved.





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #15 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: 164889@bugs.debian.org
Subject: Re: Bug#164889 acknowledged by developer (Re: Bug#164889: md5sum <FILE produces spurious ` -' in output)
Date: Wed, 16 Oct 2002 20:03:17 +0100
Debian Bug Tracking System writes ("Bug#164889 acknowledged by developer          (Re: Bug#164889: md5sum <FILE produces spurious `  -' in output)"):
> That's all well and good.  Use the bts.  This problem has already been
> discussed, and resolved.

Err, do you mean it's been fixed ?  No, I see you don't.

The fact that textutils md5sum has this bug is the reason we're not
using it.  (a) this is a gratuituous change and (b) it makes the
program less useful.

I'm reopening the bug; please leave it open while we talk about it.

Ian.



Merged 164591 164889. Request was from Ian Jackson <ian@davenant.greenend.org.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Bug reopened, originator not changed. Request was from Ian Jackson <ian@davenant.greenend.org.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: wontfix Request was from Thomas Hood <jdthood@yahoo.co.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Thomas Hood <jdthood@yahoo.co.uk>:
Extra info received and filed, but not forwarded. Copy sent to dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #26 received at 164889-quiet@bugs.debian.org (full text, mbox):

From: Thomas Hood <jdthood@yahoo.co.uk>
To: 164591@bugs.debian.org
Subject: tags 164591 wontfix
Date: 17 Oct 2002 09:09:04 +0200
tags 164591 wontfix
thanks

Adam Heath <doogie@debian.org> wrote:
> This is the way it is going to be.
--> Tagging "wontfix"

> ps: textutils md5sum acts this way

BTW, the meaning of the trailing "  -" is that this is
the md5sum of stdin.

jdthood@thanatos:~$ md5sum .bashrc
f1075ff35a46c75de41b84ac3039a8de  .bashrc
jdthood@thanatos:~$ md5sum < .bashrc
f1075ff35a46c75de41b84ac3039a8de  -

Please follow up at #164591.

--
Thomas Hood





Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Jonathan Amery <jdamery@chiark.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #31 received at 164889@bugs.debian.org (full text, mbox):

From: Jonathan Amery <jdamery@chiark.greenend.org.uk>
To: Adam Heath <adam@lapdoog.doogie.org>
Cc: Ian Jackson <ian@davenant.greenend.org.uk>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Fri, 18 Oct 2002 01:45:03 +0100
> 
> That's all well and good.  Use the bts.  This problem has already been
> discussed, and resolved.

 I can find the bug report that appears to have precipitated the
change (121489), but that has no discussion involved in it.

 Could you please provide a more helpful pointer to the discussion to
which you refer (a simple search for md5sum in dpkg's bugs proves
unhelpful).

 Thanks,

 J.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #36 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: Adam Heath <adam@lapdoog.doogie.org>
Cc: 164889@bugs.debian.org
Subject: Re: Bug#164889 acknowledged by developer (Re: Bug#164889: md5sum <FILE produces spurious ` -' in output)
Date: Fri, 18 Oct 2002 01:06:45 +0100
Ian Jackson writes ("Re: Bug#164889 acknowledged by developer          (Re: Bug#164889: md5sum <FILE produces spurious `  -' in output)"):
> The fact that textutils md5sum has this bug is the reason we're not
> using it.  (a) this is a gratuituous change and (b) it makes the
> program less useful.

Adam Heath writes ("Re: Bug#164889: md5sum <FILE produces spurious `  -' in output"):
> That's all well and good.  Use the bts.  This problem has already been
> discussed, and resolved.

Where has it been discussed ?  If the resolution is to take no action
(your statements are very unclear), I disagree for the reasons I state
above.  Please explain.

Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <doogie@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #41 received at 164889@bugs.debian.org (full text, mbox):

From: Adam Heath <doogie@debian.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>
Cc: <164889@bugs.debian.org>
Subject: Re: Disputes between developers - draft guidelines
Date: Tue, 22 Oct 2002 16:03:45 -0500 (CDT)
On Tue, 22 Oct 2002, Ian Jackson wrote:

> I'm replying privately re #164889, because I expect the rest of
> -project are deeply uninterested in that minor dispute.  If you
> disagree and want to post it there, go ahead (and this mail isn't
> secret).

I think our interactions are germane to the project, so, I'm adding a cc to
the bug, as you should have done(geez, aren't you going to even follow your
own guidelines?)

> Perhaps you missed my mails asking you where this previous discussion
> was ?  I'm afraid I still can't seem to find it.

Well, I can't find it either.  I know it has been done, tho.

> > The issue at hand has been discussed.  You have brought no knew arguments to
> > the table.  Absolutely none.  Why should we(dpkg developers) waste time
> > beating a dead horse?
>
> For example, I said in my mail of Wed, 16 Oct 2002 20:03:17 +0100:
>
>   The fact that textutils md5sum has this bug is the reason we're not
>   using it.  (a) this is a gratuituous change and (b) it makes the
>   program less useful.

Er, it's not a bug in textutils.  It never was.  It's a bug in your program
for not handling textutil's output.

> Perhaps I haven't been sufficiently clear.  Let me try again.
> I have two problems with this change:
>
> (a) It is not backwards compatible.  Existing software which uses
> md5sum and does something with the output will break (depending on the
> exact circumstances).

So, we can never ever possibly minutely even try to change?  I don't *think*
so.

The change is going to stay.  Fix your programs and scripts to be more
forgiving in what they accept.

Have you ever considered the fact that your scripts don't work with other
tools?  And that it's your scripts that are buggy?  Or do you write perfect
software all the time, and never test it?

> (b) The new behaviour leaves no way to just get the unvarnished md5sum
> of some file.  Being able to do this is quite useful if you're writing
> shell scripts and the like.

How hard is cut -f 1 -d ' ' or sed -e 's/ .*//'?




Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #46 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: Adam Heath <doogie@debian.org>
Cc: <164889@bugs.debian.org>
Subject: Re: Disputes between developers - draft guidelines
Date: Tue, 22 Oct 2002 22:14:15 +0100
Adam Heath writes ("Re: Disputes between developers - draft guidelines"):
> I think our interactions are germane to the project, so, I'm adding a cc to
> the bug, as you should have done(geez, aren't you going to even follow your
> own guidelines?)

I meant to, but I forgot.  I've sent the BTS a separate copy now.

> > Perhaps you missed my mails asking you where this previous discussion
> > was ?  I'm afraid I still can't seem to find it.
> 
> Well, I can't find it either.  I know it has been done, tho.

If you can't provide me with a reference I'm afraid I'm going to have
to ask you to repeat yourself.

> > For example, I said in my mail of Wed, 16 Oct 2002 20:03:17 +0100:
> >
> >   The fact that textutils md5sum has this bug is the reason we're not
> >   using it.  (a) this is a gratuituous change and (b) it makes the
> >   program less useful.
> 
> Er, it's not a bug in textutils.  It never was.  It's a bug in your program
> for not handling textutil's output.

By `my program' you mean the program that's calling md5sum ?

I disagree.  dpkg's md5sum comes from PGP2, and predates textutils'
version by some time.  If there is any kind of de facto specification,
then the pgp/dpkg behaviour has to be definitive.

> > (a) It is not backwards compatible.  Existing software which uses
> > md5sum and does something with the output will break (depending on the
> > exact circumstances).
> 
> So, we can never ever possibly minutely even try to change?  I don't *think*
> so.

Well, if the change were a good one, then perhaps there would be some
point in the pain of transition.  But what purpose does the change
serve ?

> > (b) The new behaviour leaves no way to just get the unvarnished md5sum
> > of some file.  Being able to do this is quite useful if you're writing
> > shell scripts and the like.
> 
> How hard is cut -f 1 -d ' ' or sed -e 's/ .*//'?

It's needless complexity.  Why have md5sum go out of its way to do
something that's actually unhelpful ?

Ian.



Information forwarded to dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and filed, but not forwarded. Copy sent to dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #51 received at 164889-quiet@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: 164889-quiet@bugs.debian.org
Subject: forwarded message from Ian Jackson
Date: Tue, 22 Oct 2002 22:11:06 +0100
[Message part 1 (message/rfc822, inline)]
From: Ian Jackson <ian@davenant.greenend.org.uk>
To: Adam Heath <doogie@brainfood.com>
Subject: Re: Disputes between developers - draft guidelines
Date: Tue, 22 Oct 2002 21:31:30 +0100
I'm replying privately re #164889, because I expect the rest of
-project are deeply uninterested in that minor dispute.  If you
disagree and want to post it there, go ahead (and this mail isn't
secret).

Adam Heath writes ("Re: Disputes between developers - draft guidelines"):
> Before I comment on any of the actual points below, I'd like to make some
> statements first.
...
> Also, for the record, shortly before this email was sent by Ian, I closed a
> bug(with a rather terse reply) filed by Ian against dpkg(the whole md5sum
> issue with 1.10).  I stand by my email.  If Ian would have done the research
> first, he would have seen that all his complaints had been previously
> discussed.

Perhaps you missed my mails asking you where this previous discussion
was ?  I'm afraid I still can't seem to find it.

> <rant>Also, as part of the above, I am annoyed when other developers
> don't use(or know how to use) the tools that are available.
> Especially if so called other developers are part of some
> semi-functional technical body, and should know better</rant>

Could you be a bit more specific ?  I'm not sure what specifically you
think I should have done that I didn't do.

> The issue at hand has been discussed.  You have brought no knew arguments to
> the table.  Absolutely none.  Why should we(dpkg developers) waste time
> beating a dead horse?

For example, I said in my mail of Wed, 16 Oct 2002 20:03:17 +0100:

  The fact that textutils md5sum has this bug is the reason we're not
  using it.  (a) this is a gratuituous change and (b) it makes the
  program less useful.

Perhaps I haven't been sufficiently clear.  Let me try again.
I have two problems with this change:

(a) It is not backwards compatible.  Existing software which uses
md5sum and does something with the output will break (depending on the
exact circumstances).

(b) The new behaviour leaves no way to just get the unvarnished md5sum
of some file.  Being able to do this is quite useful if you're writing
shell scripts and the like.

> > At no other time should you play `bug report tag' with anyone else.
> > If someone makes a change to a bug report status which you disagree
> > with you should *discuss* the matter with them but *not* immediately
> > undo their action in the BTS, except to reopen the bug to stop it
> > getting lost.  If you are unable to reach a conclusion through
> > constructive discussion, you should ask for outside help with
> > resolving your dispute, as outlined above.
> 
> Again, you're overstepping the bounds of the package maintainers.

I'm sorry, I don't follow you.

Are you saying that fighting people in the BTS is a good idea ?
Or are you saying that package maintainers never make mistakes and
should be deferred to in all things ?

Surely not; neither of these things seem like a plausible thing to
say.  Please do explain (or justify!).

Thanks,
Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Anthony Towns <aj@azure.humbug.org.au>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #56 received at 164889@bugs.debian.org (full text, mbox):

From: Anthony Towns <aj@azure.humbug.org.au>
To: Ian Jackson <ian@davenant.greenend.org.uk>, 164889@bugs.debian.org
Cc: Adam Heath <doogie@debian.org>
Subject: Re: Bug#164889: Disputes between developers - draft guidelines
Date: Wed, 23 Oct 2002 17:28:10 +1000
[Message part 1 (text/plain, inline)]
On Tue, Oct 22, 2002 at 10:14:15PM +0100, Ian Jackson wrote:
> > > (b) The new behaviour leaves no way to just get the unvarnished md5sum
> > > of some file.  Being able to do this is quite useful if you're writing
> > > shell scripts and the like.
> > How hard is cut -f 1 -d ' ' or sed -e 's/ .*//'?
> It's needless complexity.  Why have md5sum go out of its way to do
> something that's actually unhelpful ?

I've got to say I agree: "md5sum < foo" is a much more convenient and
reliable way to get useful output than messing with cut, and having a "-"
is absolutely useless; I know it came from stdin when I invoke md5sum,
and a "-" tells me absolutely _nothing_ useful at any later date (when
I might want to validate an md5sum, say). It would've been much better
to change textutil's md5sum behaviour than dpkg's.

FWIW, etc.

Cheers,
aj

-- 
Anthony Towns <aj@humbug.org.au> <http://azure.humbug.org.au/~aj/>
I don't speak for anyone save myself. GPG signed mail preferred.

 ``If you don't do it now, you'll be one year older when you do.''
[Message part 2 (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #61 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: 164889@bugs.debian.org, Anthony Towns <aj@azure.humbug.org.au>, Adam Heath <doogie@debian.org>
Subject: Re: Bug#164889: Disputes between developers - draft guidelines
Date: Fri, 25 Oct 2002 20:41:27 +0100
So let me see if I can summarise:

 * The question is, what should  md5sum < filename  do ?
   Using /dev/null as an example, the two behaviours are `bare':

   Bare:         -davenant:~> md5sum </dev/null 
  		 d41d8cd98f00b204e9800998ecf8427e
		 -davenant:~>

   Annotated:    -anarres:~> md5sum </dev/null 
		 d41d8cd98f00b204e9800998ecf8427e  -
		 -anarres:~> 

 * Historical context:

   Debian has used an md5sum in the dpkg package.  This md5sum came
   originally from PGP2.x (circa 1992/1993), and was originally
   written by Colin Plumb.  It produced the bare checksum.

   Some time in the last few years, GNU textutils gained a version of
   md5sum.  This md5sum has slightly different behaviours - it
   interprets unexpected input slightly differently for md5sum -c, and
   it also produces the annotated output in the case at issue.

   As I recall (but I could be wrong) the dpkg md5sum was, when
   textutils gained its own md5sum, briefly retired in favour of the
   textutils one.  However, the dpkg one was quickly restored, mainly
   because of the behavioural differences, including the annotation
   when taking input from stdin.

   Most recently, a version of dpkg has been uploaded whose md5sum has
   been modified to produce the annotated output.

 * You claim that the annotated behaviour is superior.

   You are concerned with compatibility with the textutils md5sum, and
   contend that this is more important than the benefits I cite below.

 * I claim that the annotated behaviour is inferior, for two reasons:

   Firstly, it is less convenient.  When md5sum is used in scripts and
   the like, it is significantly eaiser to use if it doesn't annotate
   the output, but just produces the bare checksum (in hex, with a
   trailing newline, of course).  While the advantage for any
   individual caller is small, the extra complexity and risk of bugs
   is avoidable, and of course there are many callers of md5sum so the
   pain is multiplied.

   Secondly, it is not compatible with existing programs.  Programs
   have been using and relying on the historical behaviour for some
   time, and breaking them is a bad idea.

   I contend that the textutils md5sum should be changed to match the
   PGP2 md5sum (although that's not really a question for Debian).

Do you agree with this summary ?  If not, please suggest changes.

Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #66 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: 164889@bugs.debian.org
Subject: Re: Bug#164889: Disputes between developers - draft guidelines
Date: Wed, 30 Oct 2002 23:10:04 +0000
Ian Jackson writes ("Re: Bug#164889: Disputes between developers - draft guidelines"):
> So let me see if I can summarise:
...

Do you have anything to add to that summary ?  Do you agree with it ?
If not, please let me know what you'd like to add or change.
I'd like to put the question to the Technical Committee.

Thanks,
Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>, dpkg@packages.qa.debian.org. Full text and rfc822 format available.

Message #71 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: debian-ctte@lists.debian.org
Cc: Anthony Towns <aj@azure.humbug.org.au>, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 3 Nov 2002 19:07:36 +0000
I would like to refer bugs #164591 and #164889 (these are merged, and
I'm the submitter of the latter) to the committee.  Below you'll find
my summary of the issue.  (In the summary, `you' refers to the package
maintainer.)

I sent Adam (via the BTS) this summary on the 25th of October, and
asked Adam to comment on it, and chased that up with another mail on
the 30th of October, but he has not responded to the summary.  Indeed,
he has made nearly no substantive response to my points and been, in
my view, very unhelpful.  See the BTS logs for details.

I would like the committee to overrule the maintainer.  In just a
moment I'm going to reopen the bug and reassign it to the committee.

 * The question is, what should  md5sum < filename  do ?
   Using /dev/null as an example, the two behaviours are:

   Bare:         -davenant:~> md5sum </dev/null 
  		 d41d8cd98f00b204e9800998ecf8427e
		 -davenant:~>

   Annotated:    -anarres:~> md5sum </dev/null 
		 d41d8cd98f00b204e9800998ecf8427e  -
		 -anarres:~> 

 * Historical context:

   Debian has used an md5sum in the dpkg package.  This md5sum came
   originally from PGP2.x (circa 1992/1993), and was originally
   written by Colin Plumb.  It produced the bare checksum.

   Some time in the last few years, GNU textutils gained a version of
   md5sum.  This md5sum has slightly different behaviours - it
   interprets unexpected input slightly differently for md5sum -c, and
   it also produces the annotated output in the case at issue.

   As I recall (but I could be wrong) the dpkg md5sum was, when
   textutils gained its own md5sum, briefly retired in favour of the
   textutils one.  However, the dpkg one was quickly restored, mainly
   because of the behavioural differences, including the annotation
   when taking input from stdin.

   Most recently, a version of dpkg has been uploaded whose md5sum has
   been modified to produce the annotated output.

 * You claim that the annotated behaviour is superior.

   You are concerned with compatibility with the textutils md5sum, and
   contend that this is more important than the benefits I cite below.

 * I claim that the annotated behaviour is inferior, for two reasons:

   Firstly, it is less convenient.  When md5sum is used in scripts and
   the like, it is significantly eaiser to use if it doesn't annotate
   the output, but just produces the bare checksum (in hex, with a
   trailing newline, of course).  While the advantage for any
   individual caller is small, the extra complexity and risk of bugs
   is avoidable, and of course there are many callers of md5sum so the
   pain is multiplied.

   Secondly, it is not compatible with existing programs.  Programs
   have been using and relying on the historical behaviour for some
   time, and breaking them is a bad idea.

   I contend that the textutils md5sum should be changed to match the
   PGP2 md5sum (although that's not really a question for Debian).

Thanks,
Ian.



Bug reassigned from package `dpkg' to `tech-ctte'. Request was from Ian Jackson <ian@davenant.greenend.org.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #78 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: debian-ctte@lists.debian.org, Anthony Towns <aj@azure.humbug.org.au>, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 10 Nov 2002 17:52:08 +0000
Ian Jackson writes ("Bug#164889: md5sum <FILE produces spurious ` -' in output"):
> I would like to refer bugs #164591 and #164889 (these are merged, and
> I'm the submitter of the latter) to the committee.  Below you'll find
> my summary of the issue.  (In the summary, `you' refers to the package
> maintainer.)

Apparently no-one has anything to add to my summary.

So, I hereby propose the following resolution:

 1. The Technical Committee has considered the question of the output
    format of md5sum when passed input from stdin, as discussed in
    Bug#164591 and Bug#164889.

 2. We have concluded that
     * md5sum is significantly more useful if there is a way to
       produce the `bare' output format (ie, without trailing ` -').
     * For reasons of compatiblity with scripts and other software
       which expects the historical bare output for `md5sum <file', it
       is best if that behaviour is preserved.
     * Compatibility with the historical behaviour of md5sum is more
       important than compatibility with the GNU textutils version.
    Therefore, `md5sum <file' should produce the bare output form,
    ie the MD5 checksum's hex digits followed only by a newline.

 3. We feel that the textutils md5sum should be changed to match the
    historical behaviour, both for convenience and compatibility.
    This is outside our formal jurisdiction, so we suggest that the
    submitters of the Debian bug reports take the matter up with the
    GNU coreutils maintainers.

 4. Accordingly we request (or require, if the required supermajority
    is reached according to the Constitution) that the dpkg
    maintainers reverse the change to md5sum's behavior, as described
    above.

If no-one has any further comments I'll call for a vote on this
resolution in a few days.

Ian.

PS: This all seems rather strange really - I wish someone else would
    stick their oar in ...



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Clint Adams <schizo@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #83 received at 164889@bugs.debian.org (full text, mbox):

From: Clint Adams <schizo@debian.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>
Cc: debian-ctte@lists.debian.org, Anthony Towns <aj@azure.humbug.org.au>, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 10 Nov 2002 13:29:01 -0500
>      * Compatibility with the historical behaviour of md5sum is more
>        important than compatibility with the GNU textutils version.

Rather than Debian shipping its own md5sum, why not just rely on the GNU
textutils md5sum(1) in coreutils or one of the not-yet-packaged md5(1)
utilities from *BSD, depending on whether or not one wants the '-' in
output?

Historical precedence aside, it seems to me that third-party scripts
invoking md5sum will probably want the GNU behavior, and those invoking
md5 will want the BSD behavior.

The time for changing GNU md5sum's behavior has long passed.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #88 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: Clint Adams <schizo@debian.org>
Cc: debian-ctte@lists.debian.org, Anthony Towns <aj@azure.humbug.org.au>, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 10 Nov 2002 18:33:33 +0000
Clint Adams writes ("Re: Bug#164889: md5sum <FILE produces spurious ` -' in output"):
> Rather than Debian shipping its own md5sum, why not just rely on the GNU
> textutils md5sum(1) in coreutils or one of the not-yet-packaged md5(1)
> utilities from *BSD, depending on whether or not one wants the '-' in
> output?

Please read my summary of the situation.  Debian has been shipping its
own md5sum since at least in August 1994.  It's the GNU people who've
made a change to the behaviour.

> The time for changing GNU md5sum's behavior has long passed.

The time for changing Debian md5sum's behaviour has long passed.

Also, you don't address my argument that the original behaviour is
much more convenient.

Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Clint Adams <schizo@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #93 received at 164889@bugs.debian.org (full text, mbox):

From: Clint Adams <schizo@debian.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>
Cc: debian-ctte@lists.debian.org, Anthony Towns <aj@azure.humbug.org.au>, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 10 Nov 2002 14:00:26 -0500
> Please read my summary of the situation.  Debian has been shipping its
> own md5sum since at least in August 1994.  It's the GNU people who've
> made a change to the behaviour.

Yes, and I think that the time to lobby GNU to conform to the Debian
md5sum behavior was long before GNU's md5sum established itself as THE
md5sum.  No one uses PGP2's md5sum, and I certainly wouldn't write a
script depending on the "Debian behavior".

> The time for changing Debian md5sum's behaviour has long passed.

Perhaps, but there's still time to retire it.

> Also, you don't address my argument that the original behaviour is
> much more convenient.

I don't think it's relevant.  However, since you seem to, I will point
out that it's not inconvenient for me at all.

print ${"$(print test | md5sum)"%% *}

will give me the same result whether md5sum is Debian's historical
md5sum, Debian's "rogue" md5sum, GNU's md5sum, or an alias to *BSD's md5.

Furthermore, if someone packages a BSD md5, you can get the dashless
output merely by piping to md5(1), which is 3 keystrokes more
convenient.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Raul Miller <moth@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #98 received at 164889@bugs.debian.org (full text, mbox):

From: Raul Miller <moth@debian.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>
Cc: debian-ctte@lists.debian.org, Anthony Towns <aj@azure.humbug.org.au>, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 10 Nov 2002 20:43:53 -0500
On Sun, Nov 10, 2002 at 05:52:08PM +0000, Ian Jackson wrote:
>  2. We have concluded that
>      * md5sum is significantly more useful if there is a way to
>        produce the `bare' output format (ie, without trailing ` -').

Hmm.. sorry, I let this one slip by me.

What breaks?  [An understanding of what breaks is important
for understanding how significant this change is.  I can 
imagine all sorts of possibilities, and all sorts of possible
fixes, but that's just my imagining, and not any specific
technical issue.]

Thanks,

-- 
Raul



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Anthony Towns <aj@azure.humbug.org.au>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #103 received at 164889@bugs.debian.org (full text, mbox):

From: Anthony Towns <aj@azure.humbug.org.au>
To: Raul Miller <moth@debian.org>
Cc: Ian Jackson <ian@davenant.greenend.org.uk>, debian-ctte@lists.debian.org, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 15:31:51 +1000
On Sun, Nov 10, 2002 at 08:43:53PM -0500, Raul Miller wrote:
> On Sun, Nov 10, 2002 at 05:52:08PM +0000, Ian Jackson wrote:
> >  2. We have concluded that
> >      * md5sum is significantly more useful if there is a way to
> >        produce the `bare' output format (ie, without trailing ` -').
> Hmm.. sorry, I let this one slip by me.
> What breaks?  

debootstrap broke. Things of the form:

	x=`cat foo.changes | grep blah.*deb | cut -d\  -f2`
	y=`md5sum < blah*.deb`
	if [ "$x" != "$y" ]; then
		...
	fi

(ie, get the expected md5sum from somewhere, and try to get the real md5sum
then compare) break.

I don't see why GNU textutils upstream hasn't been contacted for their
opinion. Seeing if they're willing to change textutil's behaviour from
something that seems to have no particular benefits, would seem like
the easiest way to avoid gratuitious incompatabilities with other distros.

Cheers,
aj

-- 
Anthony Towns <aj@humbug.org.au> <http://azure.humbug.org.au/~aj/>
I don't speak for anyone save myself. GPG signed mail preferred.

 ``If you don't do it now, you'll be one year older when you do.''



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Raul Miller <moth@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #108 received at 164889@bugs.debian.org (full text, mbox):

From: Raul Miller <moth@debian.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>, debian-ctte@lists.debian.org, Eduard Bloch <edi@gmx.de>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 13:54:17 -0500
On Mon, Nov 11, 2002 at 03:31:51PM +1000, Anthony Towns wrote:
> debootstrap broke. Things of the form:
> 	x=`cat foo.changes | grep blah.*deb | cut -d\  -f2`
> 	y=`md5sum < blah*.deb`
> 	if [ "$x" != "$y" ]; then

Hmm...

There are essentially two approaches to this class of problem.

[1] require that md5sum not break this kind of code.

[2] require that this code be modified to work with the "new" md5sum.

If we're going to go with [2], we can require a change of the form:

	y=`md5sum < blah*.deb | awk '{print $1}'`

Or, we can require a special option, so we get something like

	y=`md5sum --clean < blah*.deb`

I guess the technical issue here is the cost of the requisite fork()
and system behavior under degraded circumstances.  Since debootstrap
hasn't really been designed for degraded running, I don't think this
issue is significant.

Here's my opinion:

Since making this kind of change doesn't break use of the existing
md5sum, I think we should recommend that all apps using md5sum test
using the gnu variant and be modified so they work with either version.
In particular, we should allow bugs to be filed against packages which
don't support the gnu version.

Until all those bugs have been closed -- and until every package with
a md5sum dependency has had a chance to be tested -- we should forbid
deployment of the gnu version.

Also, taking a step back:

Once we're done with this specific issue, maybe we should think about
making this kind of phase-in process an option for package developers
to introduce on their own.  In other words, allow people to say:

a I'm going to change XXX in a way that breaks the existing interface.

b You have a package with a dependency on my packages which contains XXX.

c Here's one way to write code that will work with either interface.

d Here's where to get an instance of the new interface for you to test
  against.

e [stuff about bug filing/closing and the eventual release of the new
  interface]

Comments?  Opinions?

One thing that bothers me about these kind of migrations is that older
packages aren't going to know about interface changes introduced in
newer packages.  This almost requires a [potentially large and ugly]
versioned "Conflicts:" in the package which supplies the new interface.

Thanks,

-- 
Raul



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #113 received at 164889@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Raul Miller <moth@debian.org>, 164889@bugs.debian.org
Cc: debian-ctte@lists.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 20:38:05 +0100
* Raul Miller <moth@debian.org> [2002-11-11 13:54]:
> Until all those bugs have been closed -- and until every package with
> a md5sum dependency has had a chance to be tested -- we should forbid
> deployment of the gnu version.

No one will bother to check all these packages.  Instead, allow the
GNU behavior and have bugs filed on those packages that break (I guess
most have been fixed already anyway).  This is unstable after all.

-- 
Martin Michlmayr
tbm@cyrius.com



Information forwarded to tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Manoj Srivastava <srivasta@debian.org>:
Extra info received and filed, but not forwarded. Copy sent to tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #118 received at 164889-quiet@bugs.debian.org (full text, mbox):

From: Manoj Srivastava <srivasta@debian.org>
To: Raul Miller <moth@debian.org>
Cc: debian-ctte@lists.debian.org, 164889-quiet@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 15:38:54 -0600
Hi,
>>"Raul" == Raul Miller <moth@debian.org> writes:

 Raul> On Sun, Nov 10, 2002 at 05:52:08PM +0000, Ian Jackson wrote:
 >> 2. We have concluded that
 >> * md5sum is significantly more useful if there is a way to
 >> produce the `bare' output format (ie, without trailing ` -').

 Raul> Hmm.. sorry, I let this one slip by me.

 Raul> What breaks?  

	ucf - Update Configuration File - would break. Not a major
 concern to most people, since only a few emacs lisp packages use it
 yet.

	I think the Debian vote engine would need minor tweaks too.

	manoj
-- 
 TAILFINS!! ... click ...
Manoj Srivastava   <srivasta@debian.org>  <http://www.debian.org/%7Esrivasta/>
1024R/C7261095 print CB D9 F4 12 68 07 E4 05  CC 2D 27 12 1D F5 E8 6E
1024D/BF24424C print 4966 F272 D093 B493 410B  924B 21BA DABB BF24 424C



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Manoj Srivastava <srivasta@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #123 received at 164889@bugs.debian.org (full text, mbox):

From: Manoj Srivastava <srivasta@debian.org>
To: Raul Miller <moth@debian.org>
Cc: debian-ctte@lists.debian.org, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 15:49:29 -0600
>>"Raul" == Raul Miller <moth@debian.org> writes:

 Raul> On Mon, Nov 11, 2002 at 03:31:51PM +1000, Anthony Towns wrote:
 >> debootstrap broke. Things of the form:
 >> x=`cat foo.changes | grep blah.*deb | cut -d\  -f2`
 >> y=`md5sum < blah*.deb`
 >> if [ "$x" != "$y" ]; then

 Raul> Hmm...

 Raul> There are essentially two approaches to this class of problem.

 Raul> [1] require that md5sum not break this kind of code.
 Raul> [2] require that this code be modified to work with the "new" md5sum.

	Then we need a transition plan. 

 Raul> If we're going to go with [2], we can require a change of the form:

 Raul> 	y=`md5sum < blah*.deb | awk '{print $1}'`


	Fails for md5sum /some/file >> hash-file-to-be-parsed-later

 Raul> Since making this kind of change doesn't break use of the
 Raul> existing md5sum, I think we should recommend that all apps
 Raul> using md5sum test using the gnu variant and be modified so they
 Raul> work with either version.  In particular, we should allow bugs
 Raul> to be filed against packages which don't support the gnu
 Raul> version.

	wishlist bugs?

 Raul> Until all those bugs have been closed -- and until every package with
 Raul> a md5sum dependency has had a chance to be tested -- we should forbid
 Raul> deployment of the gnu version.

	How do we keep track of these bugs? 

 Raul> Also, taking a step back:

 Raul> Once we're done with this specific issue, maybe we should think about
 Raul> making this kind of phase-in process an option for package developers
 Raul> to introduce on their own.  In other words, allow people to say:

 Raul> a I'm going to change XXX in a way that breaks the existing interface.

 Raul> b You have a package with a dependency on my packages which
 Raul> contains XXX. 

 Raul> c Here's one way to write code that will work with either interface.

 Raul> d Here's where to get an instance of the new interface for you to test
 Raul>   against.

 Raul> e [stuff about bug filing/closing and the eventual release of the new
 interface> 

 Raul> Comments?  Opinions?

	This requires way more thought than this. Proper dependency
 handling isa complicated; and a generic, scalable solution takes eons
 to hammer out. 

 Raul> One thing that bothers me about these kind of migrations is that older
 Raul> packages aren't going to know about interface changes introduced in
 Raul> newer packages.  This almost requires a [potentially large and ugly]
 Raul> versioned "Conflicts:" in the package which supplies the new interface.

	Also: We need to worry about upgrades. We used to worry about
 partial upgrades -- people running mostly stable but upgrading a few
 packages from testing.


	These conficts against versions of packages that depend on on
 one could get impossible to collate; unless tools are provided that
 can walk all the dependency relationships and provide one with a
 current list (keeping in mind that some of these packages may also
 provde a versioned dependency on the package whose interface is
 changing). 

	I think this is going to be impractical unless for the very
 seldom used packages. 

	Ideally, the packages should provide a virtual package with an
 interface version embedded in them (md-interface-1.1), and packages
 depend on that interface; but even that fails to scale for packages
 that may provide multiple interfaces, only some of which are
 changing.

	manoj
-- 
 Graduating seniors, parents and friends... Let me begin by reassuring
 you that my remarks today will stand up to the most stringent
 requirements of the new appropriateness. The intra-college
 sensitivity advisory committee has vetted the text of even trace
 amounts of subconscious racism, sexism and classism. Moreover, a
 faculty panel of deconstructionists have reconfigured the rhetorical
 components within a post-structuralist framework, so as to expunge
 any offensive elements of western rationalism and linear
 logic. Finally, all references flowing from a white, male,
 eurocentric perspective have been eliminated, as have any other
 ruminations deemed denigrating to the political consensus of the
 moment.  Thank you and good luck. Doonesbury, the University
 Chancellor's graduation speech.
Manoj Srivastava   <srivasta@debian.org>  <http://www.debian.org/%7Esrivasta/>
1024R/C7261095 print CB D9 F4 12 68 07 E4 05  CC 2D 27 12 1D F5 E8 6E
1024D/BF24424C print 4966 F272 D093 B493 410B  924B 21BA DABB BF24 424C



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Raul Miller <moth@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #128 received at 164889@bugs.debian.org (full text, mbox):

From: Raul Miller <moth@debian.org>
To: Martin Michlmayr <tbm@cyrius.com>
Cc: 164889@bugs.debian.org, debian-ctte@lists.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 18:05:09 -0500
> * Raul Miller <moth@debian.org> [2002-11-11 13:54]:
> > Until all those bugs have been closed -- and until every package with
> > a md5sum dependency has had a chance to be tested -- we should forbid
> > deployment of the gnu version.

On Mon, Nov 11, 2002 at 08:38:05PM +0100, Martin Michlmayr wrote:
> No one will bother to check all these packages.  Instead, allow the
> GNU behavior and have bugs filed on those packages that break (I guess
> most have been fixed already anyway).  This is unstable after all.

Ick.  That approach encourages breakage.  [At the moment, I'm thinking
about an unrelated situation involving php4, but other situations are
possible.]

What's so hard about using apt to search for packages with the dependency,
emailing those package maintainers?

-- 
Raul



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Raul Miller <moth@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #133 received at 164889@bugs.debian.org (full text, mbox):

From: Raul Miller <moth@debian.org>
To: Manoj Srivastava <srivasta@debian.org>
Cc: debian-ctte@lists.debian.org, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 18:14:11 -0500
On Mon, Nov 11, 2002 at 03:49:29PM -0600, Manoj Srivastava wrote:
>  Raul> 	y=`md5sum < blah*.deb | awk '{print $1}'`
> 
> 	Fails for md5sum /some/file >> hash-file-to-be-parsed-later

I'm not following you.  If you're not using md5sum on stdin,
and you don't pipe through awk at all, what's the problem?

>  Raul> Since making this kind of change doesn't break use of the
>  Raul> existing md5sum, I think we should recommend that all apps
>  Raul> using md5sum test using the gnu variant and be modified so they
>  Raul> work with either version.  In particular, we should allow bugs
>  Raul> to be filed against packages which don't support the gnu
>  Raul> version.
>
> 	wishlist bugs?

Initially.  Priority should eventually be bumped up if the issue isn't
addressed and the new interface is still important.

>  Raul> Until all those bugs have been closed -- and until every package with
>  Raul> a md5sum dependency has had a chance to be tested -- we should forbid
>  Raul> deployment of the gnu version.
> 
> 	How do we keep track of these bugs? 

Hmm... I guess we don't have a tool that says "given these bug
numbers, give me the status of each".  If we had such a tool
(seems easy enough to write), package maintainer for the
package with changing interface could run [maybe it once a week]
to track progress.


> 	This requires way more thought than this. Proper dependency
>  handling isa complicated; and a generic, scalable solution takes eons
>  to hammer out. 

Ok.

> 	Ideally, the packages should provide a virtual package with an
>  interface version embedded in them (md-interface-1.1), and packages
>  depend on that interface; but even that fails to scale for packages
>  that may provide multiple interfaces, only some of which are
>  changing.

This also fails for packages which depend on something which hasn't been
virtualized yet.

More generally, unless we expose linking information at the package level
there will never be a completely automated handling of this kind of thing.
[That's what we expect package maintainers to sort out.]

Thanks,

-- 
Raul



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Manoj Srivastava <srivasta@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #138 received at 164889@bugs.debian.org (full text, mbox):

From: Manoj Srivastava <srivasta@debian.org>
To: Raul Miller <moth@debian.org>
Cc: debian-ctte@lists.debian.org, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 11 Nov 2002 19:29:41 -0600
>>"Raul" == Raul Miller <moth@debian.org> writes:

 Raul> On Mon, Nov 11, 2002 at 03:49:29PM -0600, Manoj Srivastava wrote:
 Raul> y=`md5sum < blah*.deb | awk '{print $1}'`
 >> 
 >> Fails for md5sum /some/file >> hash-file-to-be-parsed-later

 Raul> I'm not following you.  If you're not using md5sum on stdin,

	Sorry. This was a thinko. I had fallen into the mistaken
 belief that the output of the md5sums were always different, not just
 for the STDIN.

 Raul> Initially.  Priority should eventually be bumped up if the issue isn't
 Raul> addressed and the new interface is still important.

	I am unable to determine yet how important it is, especially
 since I had thought the problem was worse than it is. (ucf is not
 affected, BTW)

 Raul> Until all those bugs have been closed -- and until every package with
 Raul> a md5sum dependency has had a chance to be tested -- we should forbid
 Raul> deployment of the gnu version.
 >> 
 >> How do we keep track of these bugs? 

 Raul> Hmm... I guess we don't have a tool that says "given these bug
 Raul> numbers, give me the status of each".  If we had such a tool
 Raul> (seems easy enough to write), package maintainer for the
 Raul> package with changing interface could run [maybe it once a week]
 Raul> to track progress.

	The problem also exists of discovery -- how is that list
 initially created? How are additions to the list tracked? Once the
 list exists, I guess one may coble together scripts that handle
 deletions from the list if the bugs are closed (and, with a little
 care, track reopenings)

	Assuming there is a real list of packages that actually shall
 be affected by a change, the list we shall have may not actually
 contain all dependent packages; and some may be added as the we
 discover the dependency.

	Since the changed interface is not permitted to be introduced
 until all (most?) packages have transitioned, some of the undiscovered
 bugs won't be known until they break on the day the interface
 changed. (I am speaking to your general case here).

	manoj
-- 
 He is a man capable of turning any colour into grey. John LeCarre
Manoj Srivastava   <srivasta@debian.org>  <http://www.debian.org/%7Esrivasta/>
1024R/C7261095 print CB D9 F4 12 68 07 E4 05  CC 2D 27 12 1D F5 E8 6E
1024D/BF24424C print 4966 F272 D093 B493 410B  924B 21BA DABB BF24 424C



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Martin Michlmayr <tbm@cyrius.com>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #143 received at 164889@bugs.debian.org (full text, mbox):

From: Martin Michlmayr <tbm@cyrius.com>
To: Raul Miller <moth@debian.org>
Cc: 164889@bugs.debian.org, debian-ctte@lists.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 18 Nov 2002 15:28:04 +0100
* Raul Miller <moth@debian.org> [2002-11-11 18:05]:
> What's so hard about using apt to search for packages with the
> dependency, emailing those package maintainers?

Both dpkg and textutils are essential, and there is no md5sum package.
Therefore, no package will explicitly declare a dependency on md5um.

-- 
Martin Michlmayr
tbm@cyrius.com



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Raul Miller <moth@debian.org>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>, tech-ctte@packages.qa.debian.org. Full text and rfc822 format available.

Message #148 received at 164889@bugs.debian.org (full text, mbox):

From: Raul Miller <moth@debian.org>
To: Martin Michlmayr <tbm@cyrius.com>
Cc: 164889@bugs.debian.org, debian-ctte@lists.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Mon, 18 Nov 2002 14:16:34 -0500
> * Raul Miller <moth@debian.org> [2002-11-11 18:05]:
> > What's so hard about using apt to search for packages with the
> > dependency, emailing those package maintainers?

On Mon, Nov 18, 2002 at 03:28:04PM +0100, Martin Michlmayr wrote:
> Both dpkg and textutils are essential, and there is no md5sum package.
> Therefore, no package will explicitly declare a dependency on md5um.

Thanks, I should have looked at the package headers before asking that
question.

-- 
Raul



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. Full text and rfc822 format available.

Message #153 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: debian-ctte@lists.debian.org
Subject: md5sum <FILE produces spurious ` -' in output
Date: Fri, 7 May 2004 13:56:47 +0100
This bug has been sitting on our todo list for some time, mainly
because I've been too slack.  My apologies.  As promised, I'm now
picking it up again.

I've gone and reread the bug reports #164591 and #164889, of which I'm
the submitter of the latter, and I've written a summary of my
position, below.  Just to clarify: I would like the committee to
overrule the maintainer.

I have BCC'd this message to both bug reports, to 164591's submitter,
and to dpkg@packages, to make sure everyone knows about this
discussion.  But the discussion should probably continue on the
debian-ctte list, and not get crossposted to the bug and the package
maintainer hat.

On to the substance:

 * The question is, what should  md5sum < filename  do ?
   Using /dev/null as an example, the two behaviours are:

   Bare:         -davenant:~> md5sum </dev/null
   (IMO good)	 d41d8cd98f00b204e9800998ecf8427e
   		 -davenant:~>

   Annotated:    -anarres:~> md5sum </dev/null
   (IMO bad)     d41d8cd98f00b204e9800998ecf8427e  -
		 -anarres:~>

 * Note that there is no suggestion that the output of
   md5sum filename  should change.  It is essential that that still
   produce the `Annotated' form, eg in this case:

   With filename:  davenant:~> md5sum /dev/null
   (Good)          d41d8cd98f00b204e9800998ecf8427e  /dev/null
	           davenant:~>

   This is because that output format is used as input to `md5sum -c'.

 * I claim that the annotated behaviour is inferior, for two reasons:

   Firstly, it is less convenient.  When md5sum is used in scripts and
   the like, it is significantly easier to use if a script can get it
   not to annotate the output for a single file on stdin, but just
   produces the bare checksum (in hex, with a trailing newline, of
   course).

   Otherwise callers which want the unvarnished md5sum have to use
   seddery to strip the spurious `  -'.  While the advantage for any
   individual caller is small, the extra complexity and risk of bugs
   is avoidable, and of course there are many callers of md5sum - both
   actual Debian packages, and in the rest of the world - so the pain
   is multiplied.

   Secondly, it is not compatible with many existing programs.  Even
   though many things in Debian have already had extra code added to
   cope, programs have been using and relying on the historical
   behaviour for some time, and breaking them is a bad idea.

   I also contend that the upstream coreutils md5sum should be changed
   to match the this desirable behaviour, although that's not really a
   question for the Debian TC.

 * Opponents of my suggestion claim that the annotated behaviour is
   superior because of some need to be `compatible' with coreutils
   md5sum.

   This is a red herring.  The only case where I'm suggesting changing
   the behaviour is when the filename is _not_ supplied by the
   caller.  Ie, when you say
      md5sum < filename
   rather than
      md5sum first-file [second-file third-file ...]

   It is true that my proposed behaviour in the case of
      md5sum < filename
   is different.  It produces eg
      d41d8cd98f00b204e9800998ecf8427e
   instead of
      d41d8cd98f00b204e9800998ecf8427e  -

   But the former is very nearly strictly superior.  The latter output
   is pretty much useless as input to `md5sum -c' precisely because it
   also doesn't include the filename.

   It is possible that a small proportion of the programs which were
   changed to accept the new output by stripping the `  -' were
   changed so that they would no longer accept the old unvarnished
   form - but such programs will be rare because that makes them
   incompatible with the old behaviour of dpkg's md5sum.

 * Opponents of my suggestion have also claimed that it is not
   appropriate for the Debian maintainer to make this change and that
   instead I should get upstream coreutils to make the change first.

   I agree that it would be good for coreutils to change.  But, as a
   Debian maintainer I have to write programs which are compatible
   with the md5sum shipped in Debian.  If Debian's md5sum's behaviour
   is not restored then I will have to change my packages so that they
   cope with the new broken behaviour.  This is quite different to the
   upstream coreutils, where I can blow off bug reports saying `the
   GNU people broke it - get them to fix it again'.

   Debian has never shied away from making technically correct changes
   even if the face of opposition from upstream, and we should not do
   so now - when there is little evidence of any opposition from
   upstream.  I would of course encourage the Debian coreutils
   maintainer to talk to the GNU maintainer to try to rationalise the
   situation, but in the Debian project it's primarily the Debian
   package maintainer's responsibility to do any necessary
   communication with upstream.  I can't reasonably demand that a
   volunteer Debian maintainer actually do that work, but I don't
   think that their lack of time to do so is a good excuse for not
   fixing the bug in Debian.

   The remaining argument for waiting for the reversion to be accepted
   upstream is that we should be `compatible' with GNU coreutils so
   that other 3rd-party programs will work well on Debian.  However,
   the change does not introduce any significant incompatibility:
   programs outside Debian which feed stdin to md5sum already have to
   work with the GNU version, old PGP versions, etc., some of which
   include the spurious `  -' and some of which don't.  Programs which
   _fail_ when they cannot strip the spurious `  -' because it's
   missing will be very rare and easy to fix.

 * There has been some suggestion that there is a need to trawl
   through packages looking for ones which will break.

   As discussed above, the compatibility problems are nearly
   nonexistent.  Very probably nothing will break.  There is a small
   chance that there is some program was unwisely modified to insist
   on stripping `  -' and which now fails if it's not present.  Any
   such program should be fixed anyway to enhance its compatibility
   with non-GNU versions of md5sum including those from older Debian
   versions.

 * Historical context:

   Debian has used an md5sum in the dpkg package.  This md5sum came
   originally from PGP2.x (circa 1992/1993), and was originally
   written by Colin Plumb.  It produced the bare checksum when the
   filename wasn't supplied.  (It also provided `md5sum -c' and
   produced the corresponding output format for when the filenames
   were supplied.)

   Some time in the last few years, GNU textutils gained a version of
   md5sum.  This md5sum has slightly different behaviours - it
   interprets unexpected input slightly differently for md5sum -c, and
   it also produces the annotated output in the case at issue.

   As I recall (but I could be wrong) the dpkg md5sum was, when
   textutils gained its own md5sum, briefly retired in favour of the
   textutils one.  However, the dpkg one was quickly restored, mainly
   because of the behavioural differences, including the annotation
   when taking input from stdin.

   AIUI, most recently, a version of dpkg was been uploaded whose
   md5sum has been modified to produce the annotated output.

Thanks,
Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Technical Committee <debian-ctte@lists.debian.org>:
Bug#164889; Package tech-ctte. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Technical Committee <debian-ctte@lists.debian.org>. Full text and rfc822 format available.

Message #158 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: debian-ctte@lists.debian.org, dpkg@packages.debian.org, 164591@bugs.debian.org, 164889@bugs.debian.org
Subject: md5sum <FILE produces spurious ` -' in output
Date: Thu, 10 Jun 2004 00:15:13 +0100
Thanks to everyone for your contributions, and to the voting committee
members for your votes.  The Technical Committee has passed the
following resolution:

 1. The Technical Committe has considered the questions raised in
    Bug#164591 and Bug#164889, concerning the output format from
    md5sum when the input is stdin.

 2. For the reasons discussed below we agree with the submitters of
    the bugs, that md5sum without arguments should print only the
    checksum.

 3. We will refer to the alternative output formats as follows:
    * The `bare' format: the checksum (in hex) followed by a single
      newline.
    * The `annotated' format: the checksum (in hex) followed by two
      spaces, a hyphen, and a newline.

 4. This decision discusses and covers only the case where md5sum
    calculates and prints a single checksum, of data fed to it on
    standard input.  Other uses of md5sum are not discussed, except to
    note that we do not see any need to suggest any changes to those
    behaviours.

 5. The bare format is usually more convenient.  It would therefore be
    good for there to be a simple way to produce it.

 6. Regarding the compatibility risks of changing the behaviour, we
    note that:
    i.   The behaviour of Debian's md5sum has varied, changing several
         times between the bare and the annotated format.
    ii.  Different implementations of md5sum have different output
         formats, so that the most widespread behaviour has not been
         consistent either.
    iii. It seems unlikely to us that there are significant numbers of
         programs which depend on the annotated format.

 7. Although we do not believe the annotated format is useful except
    for compatibility reasons, it is acceptable for there to be a way
    to generate the annotated format.

 8. Other GNU utilities for reporting on the contents of files are not
    very consistent regarding when they print input filenames, but few
    utilities print the `-' when the program reads from stdin and `-'
    was not supplied as a command line argument.

 9. At least two versions of md5sum have been used in Debian - the one
    currently in the dpkg package which originated with Colin Plumb,
    and the GNU version.  Likewise, there is some discussion as to
    whether md5sum should continue to be supplied by dpkg or by the
    Debian coreutils package.  We do not address the issue of which
    version of md5sum should be used, or which package it should
    reside in.  Our conclusions apply to the utility md5sum no matter
    which version is chosen and no matter which package it is in.

10. Accordingly we request (or require, if the required supermajority
    is reached according to the Constitution) that the maintainer(s)
    of the package(s) containing md5sum cooperate to change the
    behaviour, as shown in the following examples:

    i.   Output format when no argument supplied:
	   $ md5sum </dev/null | cat -vet
	   d41d8cd98f00b204e9800998ecf8427e$
	   $

    ii.  Output when single `-' argument supplied: either
	   $ md5sum - </dev/null | cat -vet
	   d41d8cd98f00b204e9800998ecf8427e  -$
	   $
         or
	   $ md5sum - </dev/null | cat -vet
	   d41d8cd98f00b204e9800998ecf8427e$
	   $
         We recommend, but do not insist on, the former.

    iii. For other combinations of arguments we do not request
         any change in behaviour.

11. We request (or require) that the package maintainer indicate
    whether they would prefer the bug submitter to prepare a patch.
    If so then when the submitter has prepared a reasonable patch, the
    maintainer should accept and apply it if they approve; otherwise,
    or if they prefer, they should do the necessary work themselves.

12. We recommend that, if applicable, the resulting patch be sent
    upstream for inclusion in the GNU coreutils.  If Debian continues
    to use the non-GNU version, we recommend that the bug submitter
    prepare a patch to GNU coreutils and submit it to the GNU
    project.

13. We note that the issues surrounding sha1sum are similar to those
    surrounding md5sum.  We have not been asked to rule on sha1sum but
    expect that if the question arose our decision would be the same.

Votes in favour: Ian, Raul, Manoj, Guy
No other votes.

We have achieved the (AFAICT) 4:1 majority required to overrule the
maintainer.  I'll retag and reassign the bug to dpkg, and update the
committee web page.

Ian.



Tags removed: wontfix Request was from Ian Jackson <ian@davenant.greenend.org.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Bug reassigned from package `tech-ctte' to `dpkg'. Request was from Ian Jackson <ian@davenant.greenend.org.uk> to control@bugs.debian.org. Full text and rfc822 format available.

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #167 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: 164889@bugs.debian.org
Subject: md5sum <FILE produces spurious ` -' in output
Date: Sat, 19 Jun 2004 13:22:37 +0100
The Technical Committee has decided:
> 11. We [require] that the package maintainer indicate
>     whether they would prefer the bug submitter to prepare a patch.
>     If so then when the submitter has prepared a reasonable patch, the
>     maintainer should accept and apply it if they approve; otherwise,
>     or if they prefer, they should do the necessary work themselves.

Please advise.

Ian.
(I'm the submitter of one of the two reports of this problem.)



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Scott James Remnant <scott@netsplit.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #172 received at 164889@bugs.debian.org (full text, mbox):

From: Scott James Remnant <scott@netsplit.com>
To: Ian Jackson <ian@davenant.greenend.org.uk>, 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sat, 19 Jun 2004 20:02:09 +0100
[Message part 1 (text/plain, inline)]
On Sat, 2004-06-19 at 13:22 +0100, Ian Jackson wrote:

> The Technical Committee has decided:
> > 11. We [require] that the package maintainer indicate
> >     whether they would prefer the bug submitter to prepare a patch.
> >     If so then when the submitter has prepared a reasonable patch, the
> >     maintainer should accept and apply it if they approve; otherwise,
> >     or if they prefer, they should do the necessary work themselves.
> 
> Please advise.
> 
Sorry, was a little swamped (and am away this weekend and just browsing
e-mail over GPRS right now ...)

If you've got a patch to hand, that'd be great; if not, and you want to
throw one to us, that's great too -- otherwise I'll knock one up myself
when I get back.

Scott
-- 
Have you ever, ever felt like this?
Had strange things happen?  Are you going round the twist?
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #177 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: Scott James Remnant <scott@netsplit.com>
Cc: 164889@bugs.debian.org
Subject: Re: Bug#164889: md5sum <FILE produces spurious ` -' in output
Date: Sun, 20 Jun 2004 16:35:53 +0100
Scott James Remnant writes ("Re: Bug#164889: md5sum <FILE produces spurious ` -' in output"):
> Sorry, was a little swamped (and am away this weekend and just browsing
> e-mail over GPRS right now ...)

Right.

> If you've got a patch to hand, that'd be great; if not, and you want to
> throw one to us, that's great too -- otherwise I'll knock one up myself
> when I get back.

I don't have a patch to hand, no.  But given how many times this has
been changed back and forth you might be able to find one in your CVS
logs :-).  Put it on your back burner and we'll see who gets to it
first.

Thanks,
Ian.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <doogie@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #182 received at 164889@bugs.debian.org (full text, mbox):

From: Adam Heath <doogie@debian.org>
To: Ian Jackson <ian@davenant.greenend.org.uk>
Cc: debian-ctte@lists.debian.org, dpkg@packages.debian.org, 164591@bugs.debian.org, 164889@bugs.debian.org, debian-dpkg@lists.debian.org
Subject: Re: md5sum <FILE produces spurious ` -' in output
Date: Mon, 21 Jun 2004 14:26:28 -0500 (CDT)
Please don't do anything to resolve this bug, until I have had time to write a
proper reply.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Scott James Remnant <scott@netsplit.com>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #187 received at 164889@bugs.debian.org (full text, mbox):

From: Scott James Remnant <scott@netsplit.com>
To: Adam Heath <doogie@debian.org>
Cc: Ian Jackson <ian@davenant.greenend.org.uk>, debian-ctte@lists.debian.org, dpkg@packages.debian.org, 164591@bugs.debian.org, 164889@bugs.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>
Subject: Re: md5sum <FILE produces spurious ` -' in output
Date: Mon, 21 Jun 2004 21:53:34 +0100
[Message part 1 (text/plain, inline)]
On Mon, 2004-06-21 at 14:26 -0500, Adam Heath wrote:

> Please don't do anything to resolve this bug, until I have had time to write a
> proper reply.
> 
What is the "proper reply" you are writing?

Scott
-- 
Have you ever, ever felt like this?
Had strange things happen?  Are you going round the twist?
[signature.asc (application/pgp-signature, inline)]

Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Adam Heath <doogie@debian.org>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #192 received at 164889@bugs.debian.org (full text, mbox):

From: Adam Heath <doogie@debian.org>
To: Scott James Remnant <scott@netsplit.com>
Cc: Ian Jackson <ian@davenant.greenend.org.uk>, debian-ctte@lists.debian.org, dpkg@packages.debian.org, 164591@bugs.debian.org, 164889@bugs.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>
Subject: Re: md5sum <FILE produces spurious ` -' in output
Date: Mon, 21 Jun 2004 17:04:35 -0500 (CDT)
On Mon, 21 Jun 2004, Scott James Remnant wrote:

> On Mon, 2004-06-21 at 14:26 -0500, Adam Heath wrote:
>
> > Please don't do anything to resolve this bug, until I have had time to write a
> > proper reply.
> >
> What is the "proper reply" you are writing?

Something more than the single line I sent.

There are issues not discussed with the decision.



Information forwarded to debian-bugs-dist@lists.debian.org, Dpkg Development <debian-dpkg@lists.debian.org>:
Bug#164889; Package dpkg. Full text and rfc822 format available.

Acknowledgement sent to Ian Jackson <ian@davenant.greenend.org.uk>:
Extra info received and forwarded to list. Copy sent to Dpkg Development <debian-dpkg@lists.debian.org>. Full text and rfc822 format available.

Message #197 received at 164889@bugs.debian.org (full text, mbox):

From: Ian Jackson <ian@davenant.greenend.org.uk>
To: Adam Heath <doogie@debian.org>
Cc: debian-ctte@lists.debian.org, dpkg@packages.debian.org, 164591@bugs.debian.org, 164889@bugs.debian.org, debian-dpkg@lists.debian.org
Subject: Re: md5sum <FILE produces spurious ` -' in output
Date: Tue, 22 Jun 2004 20:49:36 +0100
Adam Heath writes ("Re: md5sum <FILE produces spurious ` -' in output"):
> Please don't do anything to resolve this bug, until I have had time
> to write a proper reply.

How soon can we expect that to be ?

Adam Heath writes ("Re: md5sum <FILE produces spurious ` -' in output"):
> There are issues not discussed with the decision.

If they're relevant, it's a shame that you didn't raise them earlier.
Nevertheless, I look forward to hearing about them.

Ian.



Severity set to `important'. Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Changed Bug title. Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: pending Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: fixed-in-experimental Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Tags added: fixed-in-experimental Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Tags removed: pending Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Tags removed: pending Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Bug closed, send any further explanations to Eduard Bloch <blade@debian.org> Request was from Scott James Remnant <scott@netsplit.com> to control@bugs.debian.org. Full text and rfc822 format available.

Send a report that this bug log contains spam.


Debian bug tracking system administrator <owner@bugs.debian.org>. Last modified: Sat Apr 19 07:10:21 2014; Machine Name: beach.debian.org

Debian Bug tracking system
Copyright (C) 1999 Darren O. Benham, 1997,2003 nCipher Corporation Ltd, 1994-97 Ian Jackson.